// XMLMimeFilterPP.h : Declaration of the CXMLMimeFilterPP

#ifndef __XMLMIMEFILTERPP_H_
#define __XMLMIMEFILTERPP_H_

#include "resource.h"       // main symbols

#include "Buffer.h"

/////////////////////////////////////////////////////////////////////////////
// CXMLMimeFilterPP
class ATL_NO_VTABLE CXMLMimeFilterPP : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CXMLMimeFilterPP, &CLSID_XMLMimeFilterPP>,
	public IInternetProtocol,
	public IInternetProtocolSink
{
public:
	CXMLMimeFilterPP();
	~CXMLMimeFilterPP();

DECLARE_REGISTRY_RESOURCEID(IDR_XMLMIMEFILTERPP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CXMLMimeFilterPP)
	COM_INTERFACE_ENTRY_IID(IID_IInternetProtocol, IInternetProtocol)
	COM_INTERFACE_ENTRY_IID(IID_IInternetProtocolRoot, IInternetProtocol)
	COM_INTERFACE_ENTRY_IID(IID_IInternetProtocolSink, IInternetProtocolSink)
END_COM_MAP()

// IInternetProtocol interface
public:
    STDMETHOD(Start)(
            LPCWSTR szUrl,
            IInternetProtocolSink *pIProtSink,
            IInternetBindInfo *pIBindInfo,
            DWORD grfSTI,
            DWORD dwReserved);
    STDMETHOD(Continue)(PROTOCOLDATA *pStateInfo);
    STDMETHOD(Abort)(HRESULT hrReason,DWORD dwOptions);
    STDMETHOD(Terminate)(DWORD dwOptions);
    STDMETHOD(Suspend)();
    STDMETHOD(Resume)();
    STDMETHOD(Read)(void *pv,ULONG cb,ULONG *pcbRead);
    STDMETHOD(Seek)(
            LARGE_INTEGER dlibMove,
            DWORD dwOrigin,
            ULARGE_INTEGER *plibNewPosition);
    STDMETHOD(LockRequest)(DWORD dwOptions);
    STDMETHOD(UnlockRequest)();

// IInternetProtocolSink interface
public:
    STDMETHOD(Switch)(PROTOCOLDATA __RPC_FAR *pProtocolData);       
    STDMETHOD(ReportProgress)(ULONG ulStatusCode, LPCWSTR szStatusText);      
    STDMETHOD(ReportData)(DWORD grfBSCF, ULONG ulProgress, ULONG ulProgressMax);        
    STDMETHOD(ReportResult)(HRESULT hrResult, DWORD dwError, LPCWSTR szResult);

// Public overridables
public:
	virtual void EndXMLConversion();
	virtual void BeginXMLConversion();
	virtual HRESULT ParseXMLIntoHTML(BYTE* pbuff, ULONG cbBufferSize);
// Implementation
protected:
	bool m_bFirstRead;  // whether we're starting the conversion so we can output html start
	bool m_bIncomingIsUnicode;	// Do we have incoming Unicode data?
	bool m_bSplitUniWord;		// Did the prot split a unicode word in the middle of a read?
	BYTE m_byteSplit;

	IInternetProtocolSink* m_pOutgoingProtSink;
	IInternetProtocol* m_pIncomingProt;

	DWORD m_grfSTI;							// STI flags handed to us 

	LPWSTR m_url;		// The URL... not currently using this
	CStringDataBuffer* m_pHTMLBuffer;

};
#endif //__XMLMIMEFILTERPP_H_
